<?php

/**
 * HeaderOrder.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * HeaderOrder.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class HeaderOrder
{

    /**
     * Numero de registro
     * @var int 
     */
    public $numeroReg;

    /**
     * Tipo de registro
     * @var int 
     */
    public $tipoReg;

    /**
     * Subtipo de registro
     * @var int 
     */
    public $subTipoReg;

    /**
     * version del tipo de registro
     * @var int 
     */
    public $versionReg;

    /**
     * Compañia
     * @var int 
     */
    public $cia;

    /**
     * Indicador para liquidar impuestos
     * @var int 
     */
    public $liquidaImpuesto;

    /**
     * Indica si el numero consecutivo de docto es manual o automático
     * @var int 
     */
    public $consecAutoReg;

    /**
     * Indicador de contacto
     * @var int 
     */
    public $indContacto;

    /**
     * Centro de operación del documento
     * @var string
     */
    public $idCo;

    /**
     * Tipo de documento
     * @var string
     */
    public $idTipoDocto;

    /**
     * Numero de documento
     * @var int 
     */
    public $consecDocto;

    /**
     * Fecha del documento
     * @var string
     */
    public $idFecha;

    /**
     * Clase interna del documento
     * @var int 
     */
    public $idClaseDocto;

    /**
     * Estado del documento
     * @var int 
     */
    public $indEstado;

    /**
     * Indicador backorder del documento
     * @var int 
     */
    public $indBackOrder;

    /**
     * Tercero cliente a facturar
     * @var string
     */
    public $idTerceroFact;

    /**
     * Sucursal cliente a facturar
     * @var string
     */
    public $idSucursalFact;

    /**
     * Tercero cliente a despachar
     * @var string
     */
    public $idTerceroRem;

    /**
     * Sucursal cliente a despachar
     * @var string
     */
    public $idSucursalRem;

    /**
     * Tipo de cliente
     * @var string
     */
    public $idTipoCliFact;

    /**
     * Centro de operación de la factura
     * @var string
     */
    public $idCoFact;

    /**
     * Fecha entrega del pedido
     * @var string
     */
    public $fechaEntrega;

    /**
     * Nro. dias de entrega del documento
     * @var int 
     */
    public $numDiasEntrega;

    /**
     * Orden de compra del Documento
     * @var string
     */
    public $numDoctoReferencia;

    /**
     * Referencia del documento
     * @var string
     */
    public $referencia;

    /**
     * Codigo de cargue del documento
     * @var string
     */
    public $idCargue;

    /**
     * Codigo de moneda del documento
     * @var string
     */
    public $idMonedaDocto;

    /**
     * Moneda base de conversión
     * @var string
     */
    public $idMonedaConv;

    /**
     * Tasa de conversión
     * @var int 
     */
    public $tasaConv;

    /**
     * Moneda local
     * @var string
     */
    public $idMonedaLocal;

    /**
     * Tasa local 
     * @var int
     */
    public $tasaLocal;

    /**
     * Condicion de pago
     * @var string
     */
    public $idConPago;

    /**
     * Estado de impresión del documento
     * @var int 
     */
    public $indImpresion;

    /**
     * Observaciones del documento
     * @var string
     */
    public $notas;

    /**
     * Cliente de contado
     * @var strig
     */
    public $idCliContado;

    /**
     * Punto de envio
     * @var strig
     */
    public $idPuntoEnvio;

    /**
     * Vendedor del pedido
     * @var strig
     */
    public $idTerceroVendedor;

    /**
     * Contacto
     * @var strig
     */
    public $contacto;

    /**
     * Direccion 1
     * @var strig
     */
    public $direccion1;

    /**
     * Direccion 2
     * @var strig
     */
    public $direccion2;

    /**
     * Direccion 3
     * @var strig
     */
    public $direccion3;

    /**
     * Pais
     * @var strig
     */
    public $idPais;

    /**
     * Departamento/estado
     * @var strig
     */
    public $idDepto;

    /**
     * Ciudad
     * @var strig
     */
    public $idCiudad;

    /**
     * Barrio
     * @var strig
     */
    public $idBarrio;

    /**
     * Telefono
     * @var strig
     */
    public $telefono;

    /**
     * Fax
     * @var strig
     */
    public $fax;
    
    /**
     * Codigo postal
     * @var strig
     */
    public $codPostal;

    /**
     * E-mail
     * @var strig
     */
    public $email;

    /**
     * Indicador de descuento
     * @var int 
     */
    public $indDescuento;

    /**
     * Listado de las variables de tipo Int con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2013 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsInt()
    {
        return array(
            'numeroReg' => 7,
            'tipoReg' => 4,
            'subTipoReg' => 2,
            'versionReg' => 2,
            'cia' => 3,
            'liquidaImpuesto' => 1,
            'consecAutoReg' => 1,
            'indContacto' => 1,
            'consecDocto' => 8,
            'idClaseDocto' => 3,
            'indEstado' => 1,
            'indBackOrder' => 1,
            'numDiasEntrega' => 3,
            'tasaConv' => 13,
            'tasaLocal' => 13,
            'indImpresion' => 1,
            'indDescuento' => 1,
            
        );
    }

    /**
     * Listado de las variables de tipo String con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2013 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsString()
    {
        return array(
            'idCo' => 3,
            'idTipoDocto' => 3,
            'idFecha' => 8,            
            'idTerceroFact' => 15,  
            'idSucursalFact' => 3,            
            'idTerceroRem' => 15,            
            'idSucursalRem' => 3,            
            'idTipoCliFact' => 4,            
            'idCoFact' => 3,            
            'fechaEntrega' => 8,            
            'numDoctoReferencia' => 15,            
            'referencia' => 10,     
            'idCargue' => 10,            
            'idMonedaDocto' => 3,            
            'idMonedaConv' => 3,            
            'idMonedaLocal' => 3,            
            'idConPago' => 3,            
            'notas' => 2000,            
            'idCliContado' => 15,
            'idPuntoEnvio' => 3,            
            'idTerceroVendedor' => 15, 
            'contacto' => 50,            
            'direccion1' => 40,            
            'direccion2' => 40,            
            'direccion3' => 40,            
            'idPais' => 3,            
            'idDepto' => 2,            
            'idCiudad' => 3,            
            'idBarrio' => 40,            
            'telefono' => 20,            
            'fax' => 20,            
            'codPostal' => 10,            
            'email' => 50,            
        );
    }

}

?>
