<?php

/**
 * ItemOrderOrde.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * ItemOrder.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class ItemOrder
{
    
    /**
     * Numero de registro
     * @var int
     */
    public $numeroReg;

    /**
     * Tipo de registro
     * @var int 
     */
    public $tipoReg;

    /**
     * Subtipo de registro
     * @var int 
     */
    public $subtipoReg;

    /**
     * Version del tipo de registro
     * @var int 
     */
    public $versionReg;

    /**
     * Compañía
     * @var int 
     */
    public $cia;

    /**
     * Centro de operación
     * @var string 
     */
    public $idCo;

    /**
     * Tipo de documento 
     * @var string
     */
    public $idTipoDocto;

    /**
     * Consecutivo de documento 
     * @var int 
     */
    public $r;

    /**
     * Numero de registro
     * @var int 
     */
    public $nroRegistro;

    /**
     * ItemOrder
     * @var int 
     */
    public $idItem;

    /**
     * Referencia item
     * @var string
     */
    public $referenciaItem;

    /**
     * Codigo de barras
     * @var string
     */
    public $codigoBarras;

    /**
     * Extension 1
     * @var string
     */
    public $idExt1Detalle;

    /**
     * Extension 2
     * @var string
     */
    public $idExt2Detalle;

    /**
     * Bodega
     * @var string
     */
    public $idBodega;

    /**
     * Concepto
     * @var int 
     */
    public $idConcepto;

    /**
     * Motivo
     * @var string
     */
    public $idMotivo;

    /**
     * Indicador de obsequio
     * @var int 
     */
    public $indObsequio;

    /**
     * Centro de operación movimiento
     * @var string
     */
    public $idCoMovto;

    /**
     * Unidad de negocio movimiento
     * @var string
     */
    public $idUnMovto;

    /**
     * Centro de costo movimiento
     * @var string
     */
    public $idCcostoMovto;

    /**
     * Proyecto
     * @var string
     */
    public $idProyecto;

    /**
     * Fecha entrega del pedido
     * @var string
     */
    public $fechaEntrega;

    /**
     * Nro. dias de entrega del documento
     * @var int
     */
    public $numDiasEntrega;

    /**
     * Lista de precio
     * @var string
     */
    public $idListaPrecio;

    /**
     * Unidad de medida
     * @var string
     */
    public $idUnidadMedida;

    /**
     * Cantidad base
     * @var int 
     */
    public $cantPedidaBase;

    /**
     * Cantidad adicional
     * @var int 
     */
    public $cant2pedida;

    /**
     * Precio unitario
     * @var int 
     */
    public $precioUnitario;

    /**
     * Impuestos asumidos
     * @var int 
     */
    public $indImptoAsumido;

    /**
     * Notas
     * @var string
     */
    public $notas;

    /**
     * Descripcion
     * @var string
     */
    public $detalle;

    /**
     * Indicador backorder del movimiento
     * @var int 
     */
    public $indBackorder;

    /**
     * Indicador de precio
     * @var int 
     */
    public $indPrecio;
    
    /**
     * Listado de las variables de tipo Int con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2013 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsInt()
    {
        return array(
            //Parametros para los items ----------------------------------------
            'numeroReg' => 7,
            'tipoReg' => 4,
            'subtipoReg' => 2,
            'versionReg' => 2,
            'cia' => 3,
            'r' => 8,
            'nroRegistro' => 10,
            'idItem' => 7,
            'idConcepto' => 3,
            'indObsequio' => 1,
            'numDiasEntrega' => 3,
            'cantPedidaBase' => 20,            
            'cant2pedida' => 20,
            'precioUnitario' => 20,
            'indImptoAsumido' => 1,
            'indBackorder' => 1,
            'indPrecio' => 1,            
        );
    }

    /**
     * Listado de las variables de tipo String con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2013 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsString()
    {
        return array(
            'idCo' => 3,
            'idTipoDocto' => 3,
            'referenciaItem' => 50,
            'codigoBarras' => 20,
            'idExt1Detalle' => 20,
            'idExt2Detalle' => 20,
            'idBodega' => 5,
            'idMotivo' => 2,
            'idCoMovto' => 3,
            'idUnMovto' => 20,
            'idCcostoMovto' => 15,
            'idProyecto' => 15,
            'fechaEntrega' => 8,
            'idListaPrecio' => 3,
            'idUnidadMedida' => 4,
            'notas' => 255,
            'detalle' => 2000,
        );
    }

}

?>
