<?php

/**
 * UserIdentity represents the data needed to identity a user.
 * It contains the authentication method that checks if the provided
 * data can identity the user.
 */
class UserIdentity extends CUserIdentity {

    const ERROR_STATUS_NEW = '2020';
    const ERROR_STATUS_DISABLE = '2021';
    

    /**
     * Authenticates a user.
     * The example implementation makes sure if the username and password
     * are both 'demo'.
     * In practical applications, this should be changed to authenticate
     * against some persistent user identity storage (e.g. database).
     * @return boolean whether authentication succeeds.
     */
    public function authenticate() {
        $username = Yii::app()->purifier->purify($this->username);
        $password = Yii::app()->purifier->purify($this->password);
        $users = User::model()->findByAttributes(
            array(
                'usr_username' => $username,
                'usr_password' => md5($password)
            ),
			array(
            'condition' => 'usr_status !=:status',
            'params' => array(':status' => 'd')
            )
        );

        if (!$users) {
            $this->errorCode = self::ERROR_PASSWORD_INVALID;
        } else {
            Yii::app()->session['infoUser'] = $users;
            switch ($users->usr_status) {
                case User::STATUS_NEW:
                    $this->errorCode = self::ERROR_STATUS_NEW;
                    break;
                case User::STATUS_DISABLE:
                    $this->errorCode = self::ERROR_STATUS_DISABLE;
                    break;
                default:
                    $this->errorCode = self::ERROR_NONE;                    
                    break;
            }
        }                       
        return !$this->errorCode;

/*
        if (!isset($users[$this->username]))
            $this->errorCode = self::ERROR_USERNAME_INVALID;
        else if ($users[$this->username] !== $this->password)
            $this->errorCode = self::ERROR_PASSWORD_INVALID;
        else
            $this->errorCode = self::ERROR_NONE;
        return !$this->errorCode;
 * 
 */
    }
    
    /**
     * Authenticates a user.
     * The example implementation makes sure if the username and password
     * are both 'demo'.
     * In practical applications, this should be changed to authenticate
     * against some persistent user identity storage (e.g. database).
     * @return boolean whether authentication succeeds.
     */
    public function authenticateConsole() {
        $username = $this->username;
        $users = User::model()->findByAttributes(
            array(
                'usr_username' => $username
            )
        );

        if (!$users) {
            $this->errorCode = self::ERROR_PASSWORD_INVALID;
			Yii::log(__FILE__ . ':' . __LINE__ . ':' . __FUNCTION__
                    . ':' . ' {_sendOrder ERROR ['
                    . print_r($username, true). '] USUARIO NO EXISTE}', CLogger::LEVEL_ERROR, 'b2b.ws');
        } else {
            $this->errorCode = self::ERROR_NONE;
        }                       
        return !$this->errorCode;
    }
    
    
    

}