<?php

// This is the configuration for yiic console application.
// Any writable CConsoleApplication properties can be configured here.
return array(
	'basePath'=>dirname(__FILE__).DIRECTORY_SEPARATOR.'..',
	'name'=>'b2b',
	// preloading 'log' component
    'preload' => array('log', 'bootstrap'),
	
    // path aliases
    'aliases' => array(
        'bootstrap' => realpath(__DIR__ . '/../extensions/bootstrap'),
        'yiiwheels' => realpath(__DIR__ . '/../extensions/yiiwheels'),
    ),
	// application components
        // autoloading model and component classes
        'import' => array(
            'application.models.*',
            'application.components.*',
            'application.controllers.*',
            'application.views.*',
            'application.modules.*',
            'application.extensions.*',
            'application.modules.srbac.controllers.SBaseController',
            'application.modules.srbac.components.Helper',
			'bootstrap.helpers.TbHtml',
			'application.extensions.PHPExcel.*',
			'application.extensions.PHPExcel.Classes.*',
			'application.extensions.PHPExcel.Classes.PHPExcel.*',
			'application.extensions.phpexcel.JPhpExcel'
        ),
        'modules' => array(
        // uncomment the following to enable the Gii tool
            'srbac' => array(
                'userclass' => 'User', //default: User
                'useridTable' => 'usr_user_ID', //default: userid
                //'userid' => 'user_ID', //default: userid
                'userid' => 'usr_username', //default: userid
                //'username' => 'username', //default:username
                'username' => 'usr_username', //default:username
                'delimeter' => '-', //default:-
                'debug' => false, //default :false
                'pageSize' => 10, // default : 15
                'superUser' => 'aarcila', //default: Authorizer
                'css' => 'srbac.css', //default: srbac.css
                'layout' =>
                'application.views.layouts.main', //default: application.views.layouts.main,
                //must be an existing alias
                'notAuthorizedView' => 'srbac.views.authitem.unauthorized', // default:
                //srbac.views.authitem.unauthorized, must be an existing alias
                'alwaysAllowed' => array(//default: array()
                    'SiteLogin', 'SiteLogout', 'SiteIndex', 'SiteAdmin',
                    'SiteError', 'SiteContact', 'SiteChangepass', 'SiteRepass'),
                'userActions' => array('Show', 'View', 'List'), //default: array()
                'listBoxNumberOfLines' => 15, //default : 10 
                'imagesPath' => 'srbac.images', // default: srbac.images 
                'imagesPack' => 'noia', //default: noia 
                'iconText' => true, // default : false 
                'header' => 'srbac.views.authitem.header', //default : srbac.views.authitem.header,
                 //must be an existing alias 
                'footer' => 'srbac.views.authitem.footer', //default: srbac.views.authitem.footer,
                //must be an existing alias 
                'showHeader' => true, // default: false 
                'showFooter' => true, // default: false
                'alwaysAllowedPath' => 'srbac.components', // default: srbac.components
                // must be an existing alias 
            ),

            'gii' => array(
                'class' => 'system.gii.GiiModule',
                'generatorPaths' => array('bootstrap.gii'),
                'password' => 'admin',
                // If removed, Gii defaults to localhost only. Edit carefully to taste.
                'ipFilters' => array('127.0.0.1', '::1'),
            ),
        ),
	'components'=>array(
            'request' => array(
                'hostInfo' => 'http://localhost/b2b',
                'baseUrl' => '',
                'scriptUrl' => '',
            ),
            'user' => array(
                'class' => 'ConsoleUser',
            ),
            'db' => array(
                'connectionString' => 'mysql:host=localhost;dbname=b2b',
				//'emulatePrepare' => true,
				//'enableParamLogging'=>true,
				'username' => 'usr_b2b',
				'password' => 's1stem4_b2bJDH',
				'charset' => 'utf8',
            ),
            'dbSQL' => array(
                'class' => 'CDbConnection',
                //'connectionString' => 'sqlsrv:server=DCJDHMED02;database=UnoEE_Pruebas190314',
                'connectionString' => 'sqlsrv:server=DCJDHMED02\SQLSIESA;database=UnoEE_Real',
                //'emulatePrepare' => true,            
                'username' => 'sa',
                'password' => 'Mik.123',
                'charset' => 'utf8',
            ),
            'authManager' => array(
                //'class' => 'CDbAuthManager',
                'class' => 'application.modules.srbac.components.SDbAuthManager',
                'connectionID' => 'db',
                'itemTable' => 'authitem', // Tabla que contiene los elementos de autorizacion
                'itemChildTable' => 'authitemchild', // Tabla que contiene los elementos padre-hijo
                'assignmentTable' => 'authassignment', // Tabla que contiene la signacion usuario-autorizacion
            ),
            // yiistrap configuration
            'bootstrap' => array(
                'class' => 'bootstrap.components.TbApi',
            ),
            // yiiwheels configuration
            'yiiwheels' => array(
                'class' => 'yiiwheels.YiiWheels',
            ),
            'log' => array(
                'class' => 'CLogRouter',
                'routes' => array(
                    array(
                        'class' => 'CFileLogRoute',
                        'levels' => 'trace, info, error, warning',
                    ),
                    array(
                        'class' => 'CFileLogRoute',
                        'levels' => 'trace, info, error, warning',
                        'logFile' => 'error-' . date("Y-m-d") . ".log",
                        'categories' => 'b2b.*',
                    ),
                ),
            ),
	),
        'params' => array(
            // this is used in contact page
            'RolFranquicias' => 'ComprasFranquicias',
            // 'adminEmail' => 'telemercadeo5@jdh.com.co',
            // 'asesorEmail' => 'telemercadeo5@jdh.com.co',
                    'adminEmail' => 'soporteb2bjdh@gmail.com',
            'asesorEmail' => 'soporteb2bjdh@gmail.com',
            'configMail' => array(
               //'smtp' => 'mail.jdh.com.co',
                //'smtp' => 'host110.hostmonster.com',
                'smtp' => 'smtp.gmail.com',
                //'username' => 'soporteb2b@jdh.com.co',
                //'password' => 'jdh00175',
                //'username' => 'soporte@jdh.com.co',
                //'password' => 'jdh00100',
                //'username' => 'arcila.alexander@gmail.com',
                //'password' => 'sevendust@gmail.com',
                'username' => 'soporteb2bjdh@gmail.com',
                'password' => 'jdh00175',
                //'smtp'=>'smtpout.secureserver.net',   
                //'username'=>'alexander.arcila@ingeneo.com.co',
                //'password'=>'AAA.2020',	
            ),
            'validUrl' => true,
            'rolAutorizerOrder' => array(
                'JefeCompras',
                'Vendedor'
            ),
            'nitCategoria' => array(
            //nit => categoria
            //'890900842'=>'1,2,91',
            ),
            'paramsWs' => array(
                //nit => categoria
//                'urlWs' => 'http://localhost:81/WSUNOEE/WSUNOEE.asmx?wsdl',
                'urlWs' => 'http://192.168.100.9:81/WSUNOEE/WSUNOEE.asmx?wsdl',
                //'nameConection' => 'unoeereal',            
                //'nombreDB' => 'UnoEE_Real',
                //'nombreServidorDB' => 'dcjdhmed02',
                //'usuarioDB' => 'sa',
                //'claveDB' => 'Mik.123',

				'nameConection' => 'unoee',            
                'nombreDB' => 'unoee_real',
                'nombreServidorDB' => 'DCJDHMED02\SQLSIESA',
                'usuarioDB' => 'sa',
                'claveDB' => 'Mik.123',

                'idCompania' => '1',
                'usuario' => 'usuario.b2b',
                'clave' => 'jdh0987',

            ),
            'report' => array(
                'startMonth' => '6',
            ),
            'bodegasCOFrios' => array(
                '001'=>array('72', '73'),
            ),
            'msgTooltipFecha' => 'Este campo permite conocer la fecha de 
    entrega esperada, pero no comprende un 
    compromiso por parte de JDH Distribuciones 
    para cumplir la fecha señalada',
            'msgTooltipEditar' => 'Este boton permite la edición del pedido',
            'msgTooltipLiquidar' => 'Presenta el resumen del pedido',
            'msgTooltipEliminar' => 'Elimina el pedido seleccionado',
            'msgTooltipGuardar' => 'Guarda los pedidos con estado parcialmente 
    en el sistema',
            'msgTooltipAutorizar' => 'Permite la autorización y envío de pedidos',
            'msgTooltipNuevo' => 'Guarda los cambios y permite la creación de 
    otro pedido',
            'msgTooltipSolicitar' => 'Guarda los pedidos en estado pendiente
    para ser autorizado',
            'msgTooltipSalir' => 'Sale de la creación de pedidos sin 
    guardar cambios',
        ),
);