<?php

// uncomment the following to define a path alias
// Yii::setPathOfAlias('local','path/to/local-folder');
// This is the main Web application configuration. Any writable
// CWebApplication properties can be configured here.
return array(
    'basePath' => dirname(__FILE__) . DIRECTORY_SEPARATOR . '..',
    'name' => 'B2B',
    // preloading 'log' component
    'preload' => array('log', 'bootstrap'),
    // path aliases
    'aliases' => array(
        'bootstrap' => realpath(__DIR__ . '/../extensions/bootstrap'),
        'yiiwheels' => realpath(__DIR__ . '/../extensions/yiiwheels'),
    ),
    // autoloading model and component classes
    'import' => array(
        'application.models.*',
        'application.components.*',
        'application.modules.srbac.controllers.SBaseController',
        'bootstrap.helpers.TbHtml',
        'application.extensions.PHPExcel.*',
        'application.extensions.PHPExcel.Classes.*',
        'application.extensions.PHPExcel.Classes.PHPExcel.*',
        'application.extensions.phpexcel.JPhpExcel'
    ),
    'modules' => array(
// uncomment the following to enable the Gii tool
        'srbac' => array(
            'userclass' => 'User', //default: User
            'useridTable' => 'usr_user_ID', //default: userid
            //'userid' => 'user_ID', //default: userid
            'userid' => 'usr_username', //default: userid
            //'username' => 'username', //default:username
            'username' => 'usr_username', //default:username
            'delimeter' => '-', //default:-
            'debug' => false, //default :false
            'pageSize' => 10, // default : 15
            'superUser' => 'aarcila', //default: Authorizer
            'css' => 'srbac.css', //default: srbac.css
            'layout' =>
            'application.views.layouts.main', //default: application.views.layouts.main,
//must be an existing alias
            'notAuthorizedView' => 'srbac.views.authitem.unauthorized', // default:
//srbac.views.authitem.unauthorized, must be an existing alias
            'alwaysAllowed' => array(//default: array()
                'SiteLogin', 'SiteLogout', 'SiteIndex', 'SiteAdmin',
                'SiteError', 'SiteContact', 'SiteChangepass', 'SiteRepass'),
            'userActions' => array('Show', 'View', 'List'), //default: array()
            'listBoxNumberOfLines' => 15, //default : 10 
            'imagesPath' => 'srbac.images', // default: srbac.images 
            'imagesPack' => 'noia', //default: noia 
            'iconText' => true, // default : false 
            'header' => 'srbac.views.authitem.header', //default : srbac.views.authitem.header,
//must be an existing alias 
            'footer' => 'srbac.views.authitem.footer', //default: srbac.views.authitem.footer,
//must be an existing alias 
            'showHeader' => true, // default: false 
            'showFooter' => true, // default: false
            'alwaysAllowedPath' => 'srbac.components', // default: srbac.components
// must be an existing alias 
        ),
		
        'gii' => array(
            'class' => 'system.gii.GiiModule',
            'generatorPaths' => array('bootstrap.gii'),
            'password' => 'admin',
            // If removed, Gii defaults to localhost only. Edit carefully to taste.
            'ipFilters' => array('127.0.0.1', '::1'),
        ),
    ),
    // application components
    'components' => array(
        'yexcel' => array(
            'class' => 'ext.yexcel.Yexcel'
        ),
        'clientScript' => array(
            'scriptMap' => array(
                'jquery' => true, //disable default implementation of jquery
                //'jquery.min.js'=>true,  //desable any others default implementation
                //'jquery.yii.js'=>true,  //desable any others default implementation
                'jquery.ui' => true, //desable any others default implementation
            //'core.css'=>false, //disable
            //'styles.css'=>false,  //disable
            //'pager.css'=>false,   //disable
            //'default.css'=>false,  //disable
            ),
        ),
        //Habilitar Caché
        'cache' => array(
            'class' => 'system.caching.CDbCache',
        ),
        'user' => array(
// enable cookie-based authentication
            'allowAutoLogin' => true,
        ),
        'purifier' => array(
            'class' => 'Purifier',),
        // uncomment the following to enable URLs in path-format
        /*
          'urlManager'=>array(
          'urlFormat'=>'path',
          'rules'=>array(
          '<controller:\w+>/<id:\d+>'=>'<controller>/view',
          '<controller:\w+>/<action:\w+>/<id:\d+>'=>'<controller>/<action>',
          '<controller:\w+>/<action:\w+>'=>'<controller>/<action>',
          ),
          ),
         */
        /*
          'db' => array(
          'connectionString' => 'sqlite:' . dirname(__FILE__)
          . '/../data/testdrive.db',
          ), */
        // uncomment the following to use a MySQL database
        'db' => array(
            'connectionString' => 'mysql:host=localhost;port=3306;dbname=b2b',
            //'emulatePrepare' => true,
            //'enableParamLogging'=>true,
            'username' => 'cocina_artesanal',
            'password' => 'Server.ing*90',
            'charset' => 'utf8',
        ),
        'dbSQL' => array(
            'class' => 'CDbConnection',
			'connectionString' => 'sqlsrv:server=sql.jdh.local\SQLSIESA;database=UnoEE_Real',
			//'connectionString' => 'sqlsrv:server=sql2.juandhoyos.local;database=replica_unoee',
            //'emulatePrepare' => true,            
            'username' => 'sa-ingeneo',
            'password' => 'ingeneo2020',
            'charset' => 'utf8',
        ),
        'authManager' => array(
            //'class' => 'CDbAuthManager',
            'class' => 'application.modules.srbac.components.SDbAuthManager',
            'connectionID' => 'db',
            'itemTable' => 'authitem', // Tabla que contiene los elementos de autorizacion
            'itemChildTable' => 'authitemchild', // Tabla que contiene los elementos padre-hijo
            'assignmentTable' => 'authassignment', // Tabla que contiene la signacion usuario-autorizacion
        ),
        // yiistrap configuration
        'bootstrap' => array(
            'class' => 'bootstrap.components.TbApi',
        ),
        // yiiwheels configuration
        'yiiwheels' => array(
            'class' => 'yiiwheels.YiiWheels',
        ),
        'errorHandler' => array(
// use 'site/error' action to display errors
            'errorAction' => 'site/error',
        ),
        'log' => array(
            'class' => 'CLogRouter',
            'routes' => array(
                array(
                    'class' => 'CFileLogRoute',
                    'levels' => 'error, warning',
                ),
                array(
                    'class' => 'CFileLogRoute',
                    'levels' => 'trace, info, error, warning',
                    'logFile' => 'error-' . date("Y-m-d") . ".log",
                    'categories' => 'b2b.*',
                ),
            // uncomment the following to show log messages on web pages
            /*
              array(
              'class' => 'CWebLogRoute',
              'levels' => 'trace, error, warning',
              ),
             * 
             */
            ),
        ),
    ),
    'language' => 'es',
    'theme' => 'abound',
    // application-level parameters that can be accessed
// using Yii::app()->params['paramName']
    'params' => array(
		'commandMultibranch' => 'C:\xampp\php\php.exe C:\www\htdocs\b2b\cron.php sendmultiorder',
        'RolFranquicias' => 'ComprasFranquicias',
        // 'adminEmail' => 'telemercadeo5@jdh.com.co',
	    // 'adminEmail' => 'arcila.alexander@gmail.com',
        // 'asesorEmail' => 'telemercadeo5@jdh.com.co',
		// 'adminEmail' => 'soporteb2bjdh@gmail.com',
		'adminEmail' => 'b2bsoportejdh@gmail.com',
        'asesorEmail' => 'b2bsoportejdh@gmail.com',
        'configMail' => array(
            'smtp' => 'smtp.gmail.com',
            'username' => 'b2bsoportejdh@gmail.com',
            'password' => 'dkduwdaaegeyvsxq',
        ),
        'validUrl' => true,
        'rolAutorizerOrder' => array(
            'JefeCompras',
            'Vendedor'
        ),
        'nitCategoria' => array(
        //nit => categoria
        //'890900842'=>'1,2,91',
        ),
        'paramsWs' => array(
            //nit => categoria
            'urlWs' => 'http://siesawebservice.jdh.local:1080/WSUNOEE/WSUNOEE.asmx?wsdl',
			'nameConection' => 'unoee',            
            'nombreDB' => 'unoee_real',
            'nombreServidorDB' => 'SQL\SQLSIESA',
            'usuarioDB' => 'sa',
            'claveDB' => 'Mik.123',			
            'idCompania' => '1',
            'usuario' => 'usuario.b2b',
            'clave' => 'jdh0987',
			
        ),
        'report' => array(
            'startMonth' => '6',
        ),
        'bodegasCOFrios' => array(
            '001'=>array('72', '75', 'MDE3'),
			'003'=>array('BTA8'),
        ),
        'msgTooltipFecha' => 'Este campo permite conocer la fecha de 
entrega esperada, pero no comprende un 
compromiso por parte de JDH Distribuciones 
para cumplir la fecha señalada',
        'msgTooltipEditar' => 'Este boton permite la edición del pedido',
        'msgTooltipLiquidar' => 'Presenta el resumen del pedido',
        'msgTooltipEliminar' => 'Elimina el pedido seleccionado',
        'msgTooltipGuardar' => 'Guarda los pedidos con estado parcialmente 
en el sistema',
        'msgTooltipAutorizar' => 'Permite la autorización y envío de pedidos',
        'msgTooltipNuevo' => 'Guarda los cambios y permite la creación de 
otro pedido',
        'msgTooltipSolicitar' => 'Guarda los pedidos en estado pendiente
para ser autorizado',
        'msgTooltipSalir' => 'Sale de la creación de pedidos sin 
guardar cambios',
    ),
);
