<?php

/**
 * This is the model class for table "b2b_city_cellar".
 *
 * The followings are the available columns in table 'b2b_city_cellar':
 * @property string $id
 * @property integer $cce_country_id
 * @property string $cce_country
 * @property integer $cce_depto_id
 * @property string $cce_departament
 * @property integer $cce_city_id
 * @property string $cce_city
 * @property string $cce_co
 * @property string $cce_cellar
 * @property string $cce_created
 * @property string $cce_modified
 */
class Citycellar extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'b2b_city_cellar';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('cce_country, cce_departament, cce_city, cce_modified', 'required'),
			array('cce_country_id, cce_depto_id, cce_city_id', 'numerical', 'integerOnly'=>true),
			array('cce_country', 'length', 'max'=>150),
			array('cce_departament, cce_city', 'length', 'max'=>250),
			array('cce_co, cce_cellar', 'length', 'max'=>50),
			array('cce_created', 'safe'),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, cce_country_id, cce_country, cce_depto_id, cce_departament, cce_city_id, cce_city, cce_co, cce_cellar, cce_created, cce_modified', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'cce_country_id' => 'Cce Country',
			'cce_country' => 'Cce Country',
			'cce_depto_id' => 'Cce Depto',
			'cce_departament' => 'Cce Departament',
			'cce_city_id' => 'Cce City',
			'cce_city' => 'Cce City',
			'cce_co' => 'Cce Co',
			'cce_cellar' => 'Cce Cellar',
			'cce_created' => 'Cce Created',
			'cce_modified' => 'Cce Modified',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id,true);
		$criteria->compare('cce_country_id',$this->cce_country_id);
		$criteria->compare('cce_country',$this->cce_country,true);
		$criteria->compare('cce_depto_id',$this->cce_depto_id);
		$criteria->compare('cce_departament',$this->cce_departament,true);
		$criteria->compare('cce_city_id',$this->cce_city_id);
		$criteria->compare('cce_city',$this->cce_city,true);
		$criteria->compare('cce_co',$this->cce_co,true);
		$criteria->compare('cce_cellar',$this->cce_cellar,true);
		$criteria->compare('cce_created',$this->cce_created,true);
		$criteria->compare('cce_modified',$this->cce_modified,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Citycellar the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
