<?php

/**
 * This is the model class for table "b2b_unida_medida".
 *
 * The followings are the available columns in table 'b2b_unida_medida':
 * @property integer $unm_id
 * @property string $unm_nit
 * @property string $unm_referencia
 * @property string $unm_unidad_medida
 */
class UnidadMedida extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'b2b_unidad_medida';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('unm_referencia, unm_unidad_medida', 'required'),
			array('unm_nit, unm_referencia, unm_unidad_medida', 'length', 'max'=>50),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('unm_id, unm_nit, unm_referencia, unm_unidad_medida', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'unm_id' => 'Unm',
			'unm_nit' => 'Unm Nit',
			'unm_referencia' => 'Unm Referencia',
			'unm_unidad_medida' => 'Unm Unidad Medida',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('unm_id',$this->unm_id);
		$criteria->compare('unm_nit',$this->unm_nit,true);
		$criteria->compare('unm_referencia',$this->unm_referencia,true);
		$criteria->compare('unm_unidad_medida',$this->unm_unidad_medida,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return UnidaMedida the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
