<?php
/* @var $this BudgetController */
/* @var $model Budget */
/* @var $form CActiveForm */
?>

<div class="form">

<?php $form=$this->beginWidget('bootstrap.widgets.TbActiveForm', array(
	'id'=>'buget',
	// Please note: When you enable ajax validation, make sure the corresponding
	// controller action is handling ajax validation correctly.
	// There is a call to performAjaxValidation() commented in generated controller code.
	// See class documentation of CActiveForm for details on this.
	'enableAjaxValidation'=>false,
)); ?>
        
        <?php if(count($listClient) < 1 || count($listBranch) < 1): ?>    
        <div class="alert alert-block alert-error">
            - El usuario no posee clientes o sucursales asociadas
            <br>
            - Ya no puede asignar mas presupuestos
        </div>
        <?php else: ?> 

	<p class="note">Los campos con <span class="required">*</span> son requeridos.</p>

	<?php echo $form->errorSummary($model); ?>	
        
        <table class="items table">
        <tr>
            <td><h5>Cliente:</h5></td>
            <td><?php
                if($model->isNewRecord){
                echo CHtml::dropDownList('codClient', $defaultClient,
                    $listClient, array('style' => 'width: 400px'));
                }else{
                    echo CHtml::dropDownList('codClient', $defaultClient,
                    $listClient, array('style' => 'width: 400px','disabled'=>true));
                }
                ?></td>        
            <td><h5>Sucursal:</h5></td>
            <td><div id="dropBranch">
                <?php                    
                $this->widget('yiiwheels.widgets.select2.WhSelect2',
                    array(
                    'asDropDownList' => true,
                    'language' => 'es',
                    'model' => $model,
                    'attribute' => 'id_cln_id',                        
                    'data' => $listBranch,
                    'htmlOptions' => array(
                        //'multiple' => 'basic',
                        'id' => 'id_cln_id',
                        'selected' => $defaultBranch
                    ),
                    'pluginOptions' => array(
                        //'placeholder' => 'Seleccione',
                        'minimumInputLength' => 3,
                        'width' => '85%',
                    //'tokenSeparators' => array(',', ' ')
                    ),
                ));
                ?>
            </div></td> 
        </tr>
        <tr>
            <td><h5>Presupuesto:</h5></td>
            <td><?= $form->textField($model,'bud_budget');?></td> 
            <td><h5>Bloquear pedidos:</h5></td>
            <td><?= $form->dropdownlist($model,'bud_block',
                    array('NO'=>'NO', 'SI'=>'SI')); ?></td>
        </tr>
    </table>
	

	<div class="">
		<?php echo CHtml::submitButton($model->isNewRecord ? 'Crear' : 'Guardar',array('class' => 'btn btn-primary')); ?>
	</div>
<?php endif; ?> 
<?php $this->endWidget(); ?>

</div><!-- form -->

<script type="text/javascript">
    /**
     * Cambios de cliente
     */
    $('#codClient').change(
            function(event) {
                changeBranch();
            });

    /**
     * Metodo para consultar las sucursales 
     * disponibles segun el nit
     * @returns {undefined}
     */
    function changeBranch() {
		distractor.show();
        nit = $("#codClient").val();
        $("#nit").html(nit);
        $.ajax({url: '<?php echo CController::createUrl('budget/getListBranchBudget') ?>',
            type: "post",
            data: {nit: nit},
            success: function(data) {
                $("#dropBranch").html(data);
                $('#button-search').removeAttr('disabled');
				distractor.hide();
            }});
    }

</script>