<?php
/* @var $this OrderController */
/* @var $model Order */
?>

<?php
$this->breadcrumbs = array(
    'Pedidos' => array('index'),
    'Cargar pedido',
);
/**
  $this->menu=array(
  array('label'=>'List Order', 'url'=>array('index')),
  array('label'=>'Manage Order', 'url'=>array('admin')),
  );
 * 
 */
Yii::app()->clientScript->registerCoreScript('jquery');
?>

<h2>Ingreso de Pedidos - Carga de archivo - Vendedores</h2>

<div class="form">

    <?php
    $form = $this->beginWidget('bootstrap.widgets.TbActiveForm',
        array(
        'id' => 'loadfile-form',
        // Please note: When you enable ajax validation, make sure the corresponding
        // controller action is handling ajax validation correctly.
        // There is a call to performAjaxValidation() commented in generated controller code.
        // See class documentation of CActiveForm for details on this.
        'enableAjaxValidation' => false,
        'htmlOptions' => array(
            'enctype' => 'multipart/form-data',
            'class' => 'fileupload',
        )
    ));
    ?>
    <?php echo $form->errorSummary($model); ?>
    <?php $this->widget('bootstrap.widgets.TbAlert'); ?>

    <div id="div-error" style="display: none;">
        <a class="close" type="button" data-dismiss="alert" href="#">×</a>
    </div>

    <?php if(count($listClient) < 1 || count($listBranch) < 1): ?>    
        <div class="alert alert-block alert-error">
            El usuario no posee clientes o sucursales asociadas
        </div>
    <?php else: ?> 
        <table class="items table" >
            <tr>
                <td><h5>Objeto del pedido
                        <span class="required">*</span> :</h5></td>
                <td class="radioButton" colspan="3"><?php
                    echo $form->inlineRadioButtonList($model, 'ord_objOrder',
                        array(
                        $model::COD_FACTURACION => 'Facturación',
                        $model::COD_REMISION => 'Remisión'),
                        array(
                        ''
                        )
                    );
                    ?></td>
                <td><h5>Descarga de catálogo</h5></td>
                <td><?php
                    echo TbHtml::link('Excel ' . CHtml::image('images/excel.png'),
                        'javascript:void(0)',
                        array(
                        'id' => 'downFileExcel',
                        'class' => 'downFile',
                    ));
                    ?> 
                    <?php
                    echo TbHtml::link('Archivo plano ' . CHtml::image('images/file.png'),
                        'javascript:void(0)',
                        array(
                        'id' => 'downFileText',
                        'class' => 'downFile',
                    ));
                    ?></td>
            </tr>
            <tr>
                <td><h5>Nit:</h5></td>
                <td><div id="nit"><?php echo $defaultClient ?></div></td>
                <td><h5>Cliente:</h5></td>
                <td><?php
                    echo CHtml::dropDownList('codClient', $defaultClient,
                        $listClient, array('style' => 'width: 400px'))
                    ?></td>    
                <td><h5>Número de la orden</h5></td>
                <td><?php
                    echo $form->textField($model, "ord_number")
                    ?></td>
            </tr>        
            <tr>
                <td><h5>Código sucursal:</h5></td>
                <td><div id="branch"><?php echo $defaultBranch; ?></div></td>
                <td><h5>Sucursal:</h5></td>
                <td><div id="dropBranch"><?php
//                        echo CHtml::dropDownList('codeBranch', $defaultBranch,
//                            $listBranch)
                        ?>
                        <?php
                        $this->widget('yiiwheels.widgets.select2.WhSelect2',
                            array(
                            'asDropDownList' => true,
                            'language' => 'es',
                            //'model' => $model,
                            //'attribute' => 'codeBranch',
                            'name' => 'codeBranch',
                            'data' => $listBranch,
                            'htmlOptions' => array(
                                //'multiple' => 'basic',
                                'id' => 'codeBranch',
                                'selected' => $defaultBranch
                            ),
                            'pluginOptions' => array(
                                //'placeholder' => 'Seleccione',
                                'minimumInputLength' => 3,
                                'width' => '85%',
                            //'tokenSeparators' => array(',', ' ')
                            ),
                        ));
                        ?>
                    </div></td>            
                <td><h5>Fecha entrega esperada
                        <span class="required">*</span> :</h5></td>
                <td><div id="date-label" style="display: none"></div>
                    <div id="date">
                        <div class="input-append">
                            <?php
                            $this->widget('yiiwheels.widgets.datepicker.WhDatePicker',
                                array(
                                'value' => $model->ord_date,
                                'name' => 'Order[ord_date]',
                                'htmlOptions' => array(
                                    'placeholder' => 'Seleccione',
                                    'readonly' => 'readonly',
                                    'title' => Yii::app()->params['msgTooltipFecha']
                                //'id'=>'Order-ord-date'
                                ),
                                'pluginOptions' => array(
                                    'format' => 'yyyy-mm-dd',
                                    'language' => 'es',
                                    'dates' => 'es'
                                )
                            ));
                            ?>
                            <span class="add-on"><icon class="icon-calendar"></icon></span>
                        </div>
                    </div>
                </td>
            </tr> 
            <tr>
                <td><h5>Descripción: </h5></td>
                <td colspan="5">
                    <?php
                    echo $form->textArea(
                        $model, 'ord_description',
                        array(
                        'rows' => 1,
                        'class' => 'span12',
                        //'maxlength'=>500
                        )
                    );
                    ?> 
                </td>
            </tr>
        </table>        
        <div class="alert alert-block alert-success">
            Antes de cargar el archivo tenga en cuenta lo siguiente:
            <ul>
                <li>
                    Tamaño máximo <strong>2 MB</strong> - 
                    Formatos permitidos <strong>xls, xlsx, txt</strong>
                </li>                
                <li>
                    Se toman los registros a partir de la 
                    <strong>segunda posición</strong>
                </li>
                <li>
                    Descargue el listado de items según el 
                    nit y la sucursal de la seccion <strong>Descarga
                        de catálogo</strong>
                </li>
            </ul>
        </div>                

        <?php
        $this->widget('yiiwheels.widgets.fineuploader.WhFineUploader',
            array(
            'name' => 'Order[uploadFile]',
            'uploadAction' => $this->createUrl('order/loadfilesales',
                array('fine' => 1)),
            'pluginOptions' => array(
                //'debug' => true,
                'validation' => array(
                    'allowedExtensions' => array('xls', 'xlsx', 'txt')
                ),
                'params' => array(
                    'nit' => '$("#codClient").val()',
                    'codeBranch' => '$("#codeBranch").val()',
                )
            ),
            'events' => array(
                'submit' => 'js: function(id, fileName) {
                    nit = $("#codClient").val();
                    codeBranch = $("#codeBranch").val();
                    $(this).fineUploader("setParams", 
                        {"nit":nit, "codeBranch": codeBranch}); 
                }',
                'complete' => 'js:function(event, id, fileName, responseJSON){
                    jQuery("#error-loadFile").hide();
                    if(responseJSON.success){
                       $("#liquidar").removeClass("disabled");                       
                       $("#buttom").show();                    
                       $("#form-products").html(responseJSON.html);
                    }
                    if(responseJSON.msgError){     
                       $("#form-products").html("");
                       $("#error-loadFile").html(responseJSON.msgError);                       
                       $("#error-loadFile").show();
                    }
                }'
            ),
        ));
        ?>
        <br/>
        <div id="error-loadFile" class="alert alert-block alert-error" style="display: none;">
            <a class="close" type="button" data-dismiss="alert" href="#">×</a>
        </div>
        <div id="form-products"></div>
        <div id="div-status"></div>
        <div><?php
            echo CHtml::hiddenField('type', 'file');
            ?></div>
    <?php endif; ?>    
<?php $this->endWidget(); ?>

</div><!-- form -->
<script type="text/javascript">

    $(document).ready(function() {
        $('#loadfile-form').find("input[type='radio']:checked").removeAttr('checked');
        validateQuotaBranch('<?php echo CController::createUrl('order/validateQuotaBranch')  ?>');
    });

    $('#codClient').change(
            function(event) {
                changeBranch();
            });

    $('#codeBranch').change(
            function(event) {
                codeBranch = $("#codeBranch").val();
                $("#branch").html(codeBranch);
                validateQuotaBranch('<?php echo CController::createUrl('order/validateQuotaBranch')  ?>');;
            });


    $('.downFile').click(function() {
        var id = $(this).attr('id');
        if (id === 'downFileExcel') {
            type = 'excel';
        } else {
            type = 'text';
        }
        nit = $('#codClient').val();
        codBranch = $('#codeBranch').val();
        url = "<?php echo CController::createUrl('order/loadfilesales',
    array('ajax' => 'download'));
?>"
                + "&nit=" + nit + "&codeBranch=" + codBranch + "&type=" + type;
        window.location.href = url;
    });

    /**
     * Metodo para la validacion de los campos
     */
    function send(id) {
        showDistractor();
        //hideDistractor();
        formId = 'loadfile-form';
        urlSubmit = "<?php echo CController::createUrl('order/createordersales'); ?>";
        addStatus(id);
        var form = jQuery('#' + formId);
        $.ajax({
            type: 'POST',
            url: "<?php echo CController::createUrl('order/createordersales'); ?>",
            data: form.serialize() + "&ajax=order-form",
            cache: false,
            async: false,
            success: function(data) {
                if (data != null && $.trim(data)) {
                    newData = data.replace('class="errorSummary"', '');
                    showError(newData);
                    $('#buttom').find('button').removeAttr('disabled');
                    hideDistractor();
                    return false;
                }
                showError('');
                enabledForm(formId);
                form.attr('action', urlSubmit);
                form.submit();
            },
            error: function(data) {
                hideDistractor();
                showError('A ocurrido un error, comuníquese con el administrador');
                return false;
            }
        });
        return false;
    }

    /**
     * Metodo para consultar las sucursales 
     * disponibles segun el nit
     * @returns {undefined}
     */
    function changeBranch() {
		distractor.show();
        nit = $("#codClient").val();
        $("#nit").html(nit);
        $.ajax({url: '<?php echo CController::createUrl('order/getBranch') ?>',
            type: "post",
            data: {nit: nit, load: 'load'},
            success: function(data) {
                $("#dropBranch").html(data);
				codeBranch = $("#codeBranch").val();
				$("#branch").html(codeBranch);
            },
			complete: function(){
			  validateQuotaBranch('<?php echo CController::createUrl('order/validateQuotaBranch') ?>');
			  distractor.hide();
		    }});
    }

    /**
     * Funcion para salir  
     * @returns {undefined}     
     */
    function exitOrder() {
        if (confirm('¿Desea salir de la creación de pedidos?. \n\
Recuerde que los cambios se perderán')) {
            showDistractor();
            var url = "<?php echo Yii::app()->createUrl('order/admin') ?>";
            $(location).attr('href', url);
        }
    }



    /**
     * Metodo que adiciona el estado al formulario
     * @param {type} id
     * @returns {String}
     */
    function addStatus(id) {
        if (id == "button-new") {
            inputStatus = '<?php
echo CHtml::hiddenField('status', Order::ORDER_NEW);
?>';
            $('#div-status').html(inputStatus);
        }

        if (id == "button-allow") {
            inputStatus = '<?php
echo CHtml::hiddenField('status', Order::STATUS_ALLOW);
?>';
            $('#div-status').html(inputStatus);
        }

        if (id == "button-getAllow") {
            inputStatus = '<?php
echo CHtml::hiddenField('status', Order::STATUS_PENDING);
?>';
            $('#div-status').html(inputStatus);
        }
    }

</script>
