<?php
/* @var $this ReportController */

$this->breadcrumbs = array(
    'Reporte' => array('/report/orderbudget'),
    'Reporte Control de presupuesto',
);
?>
<h2>Reporte - Control de presupuesto</h2>

<div class="form">
    <?php
    $form = $this->beginWidget('bootstrap.widgets.TbActiveForm',
        array(
        'id' => 'reportPortfolio',
        'enableAjaxValidation' => false,
    ));
    ?>
    
    <?php $this->widget('bootstrap.widgets.TbAlert'); ?>
    
    <?php if(count($listClient) < 1 || count($listBranch) < 1): ?>    
        <div class="alert alert-block alert-error">
            El usuario no posee clientes o sucursales asociadas
        </div>
    <?php else: ?> 
        <table class="items table" >
            <tr>
                <td><h5>Fecha Inicial: </h5></td>
                <td><div class="input-append">
                        <?php
                        $this->widget('yiiwheels.widgets.datepicker.WhDatePicker',
                            array(
                            'value' => $startDate,
                            'name' => 'start_date',
                            'htmlOptions' => array(
                                'placeholder' => 'Seleccione',
                                'readonly' => 'readonly',
								//'id'=>'Order-ord-date'
                            ),
                            'pluginOptions' => array(
                                'format' => 'dd-mm-yyyy',
                                'language' => 'es',
                                'dates' => 'es',
				'startDate' => '-'.Yii::app()->params['report']['startMonth'].'m',
				'endDate' => "+Infinity",
                           ),							
                        ));
                        ?>
                        <span class="add-on">
							<i class="icon-calendar"></i>
						</span>
                    </div>                
                </td>
                <td><h5>Fecha Final: </h5></td>
                <td><div class="input-append">
                        <?php
                        $this->widget('yiiwheels.widgets.datepicker.WhDatePicker',
                            array(
                            'value' => $endDate,
                            'name' => 'end_date',
                            'htmlOptions' => array(
                                'placeholder' => 'Seleccione',
                                'readonly' => 'readonly',
                            //'id'=>'Order-ord-date'
                            ),
                            'pluginOptions' => array(
                                'format' => 'dd-mm-yyyy',
                                'language' => 'es',
                                'dates' => 'es',
                                'startDate' => '-'.Yii::app()->params['report']['startMonth'].'m',
				'endDate' => "+Infinity",
                            )
                        ));
                        ?>
                        <span class="add-on">
                            <icon class="icon-calendar"></icon></span>
                    </div>                
                </td>
            </tr>
            <tr>
                <td><h5>Cliente:</h5></td>
                <td><?php
                    echo CHtml::dropDownList('codClient', $defaultClient,
                        $listClient, array('style' => 'width: 400px'))
                    ?></td>        
                <td><h5>Sucursal:</h5></td>
                <td><div id="dropBranch">
                        <?php
                        $this->widget('yiiwheels.widgets.select2.WhSelect2',
                            array(
                            'asDropDownList' => true,
                            'language' => 'es',
                            //'model' => $model,
                            //'attribute' => 'codeBranch',
                            'name' => 'codeBranch',
                            'data' => $listBranch,
                            'htmlOptions' => array(
                                //'multiple' => 'basic',
                                'id' => 'codeBranch',
                                'selected' => $defaultBranch
                            ),
                            'pluginOptions' => array(
                                //'placeholder' => 'Seleccione',
                                'minimumInputLength' => 3,
                                'width' => '85%',
                            //'tokenSeparators' => array(',', ' ')
                            ),
                        ));
                        ?>
                    </div></td> 
            </tr>
            <tr>
                
                
                <td colspan="10">
                    
                <?php echo $form->RadioButtonListControlGroup($model,'radioButton', 
                      array('facturados' => 'Facturados',
                      'remisionados' => 'Remisionados'),
                        array('label' => '<h5>Seleccione el tipo: </h5>')); ?></td>
                
            </tr>
        </table>
        <?php
        echo TbHtml::submitButton('Buscar',
            array(
            'id' => 'button-search',
            'color' => TbHtml::BUTTON_COLOR_PRIMARY,
            'size' => TbHtml::BUTTON_SIZE_DEFAULT,
            //'onClick' => 'search()',
        ));
        ?>
        <br/>
        <br>
        <br>
        
        <?php if(!empty($tipo)){ ?>
        <h3>Información de los pedidos <?= $tipo; ?></h3>
        <table class="items table" >
    <tr>
        <td><strong>Presupuesto de la sucursal:</strong></td>
        <td>$ <?php echo number_format($presupuesto); ?></td>      
    </tr>
</table>
        
        <?php }else{ } ?>
        <?php
            
        $this->widget('yiiwheels.widgets.grid.WhGridView',
            array(
            'id' => 'myorders',
            'type' => 'striped bordered',
            'dataProvider' => $dataProvider,
            'fixedHeader' => true,
            //'template' => "{items}",
            'columns' => array_merge(array(                
                array(
                    'name' => 'Nit Cliente',
                    ),
                array('name'=>'Nombre Cliente'),
		array('name'=>'Nombre Sucursal Factura'),
                array('name'=>'Nombre Sucursal Remision'),
                array('header'=>'Valor Facturado','name'=>'Valor_Facturado','value'=> function($data){ return "$ ". number_format($data['Valor_Facturado']);} ),
                array('header'=>'Valor Remisionado','name'=>'Valor_Remisionado','value'=> function($data){ return "$ ". number_format($data['Valor_Remisionado']);} ),
                array('name'=>'Subtotal con Iva','value'=> function($data){ return "$ ". number_format($data['Subtotal con Iva']);} ),
                array('name'=>'Subtotal Sin Iva','value'=> function($data){ return "$ ". number_format($data['Subtotal Sin Iva']);} ),
                
                )) 
        ));
        ?>
    <?php endif; ?> 
    <?php $this->endWidget(); ?>
</div><!-- form -->

<script type="text/javascript">
    /**
     * Cambios de cliente
     */
    $('#codClient').change(
            function(event) {
                changeBranch();
            });

    /**
     * Metodo para consultar las sucursales 
     * disponibles segun el nit
     * @returns {undefined}
     */
    function changeBranch() {
	distractor.show();
        nit = $("#codClient").val();
        $('#button-search').attr('disabled', 'disabled');
        $("#nit").html(nit);
        $.ajax({url: '<?php echo CController::createUrl('report/getBranch') ?>',
            type: "post",
            data: {nit: nit},
            success: function(data) {
                $("#dropBranch").html(data);
                $('#button-search').removeAttr('disabled');
				distractor.hide();
            }});
    }    

</script>
